<?php
if ( ! class_exists( 'Property_Broker_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Property_Broker_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Property_Broker_Plugin_Activation_WPElemento_Importer {

        private static $property_broker_instance;
        public $property_broker_action_count;
        public $property_broker_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$property_broker_instance) ) {
            self::$property_broker_instance = new self();
          }
          return self::$property_broker_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'property_broker_recommended_plugins', array($this, 'property_broker_recommended_elemento_importer_plugins_array') );

            $property_broker_actions                   = $this->property_broker_get_recommended_actions();
            $this->property_broker_action_count        = $property_broker_actions['count'];
            $this->property_broker_recommended_actions = $property_broker_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function property_broker_recommended_elemento_importer_plugins_array($property_broker_plugins){
            $property_broker_plugins[] = array(
                    'name'     => esc_html__('Mizan Demo Importor', 'property-broker'),
                    'slug'     =>  'mizan-demo-importer',
                    'function' => 'Mizan_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the Mizan Demo Importor plugin for importing the demo content with Elementor.', 'property-broker'),               
            );
            return $property_broker_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'property-broker-plugin-activation-script', esc_url(get_template_directory_uri()) . '/inc/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('property-broker-plugin-activation-script', 'property_broker_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'property-broker'),
                    'activating' => esc_html__('Activating', 'property-broker'),
                    'error' => esc_html__('Error', 'property-broker'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=mizan-demo-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=mizandemoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'property-broker-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function property_broker_get_recommended_actions() {

            $property_broker_act_count  = 0;
            $property_broker_actions_todo = get_option( 'recommending_actions', array());

            $property_broker_plugins = $this->property_broker_get_recommended_plugins();

            if ($property_broker_plugins) {
                foreach ($property_broker_plugins as $property_broker_key => $property_broker_plugin) {
                    $property_broker_action = array();
                    if (!isset($property_broker_plugin['slug'])) {
                        continue;
                    }

                    $property_broker_action['id']   = 'install_' . $property_broker_plugin['slug'];
                    $property_broker_action['desc'] = '';
                    if (isset($property_broker_plugin['desc'])) {
                        $property_broker_action['desc'] = $property_broker_plugin['desc'];
                    }

                    $property_broker_action['name'] = '';
                    if (isset($property_broker_plugin['name'])) {
                        $property_broker_action['title'] = $property_broker_plugin['name'];
                    }

                    $property_broker_link_and_is_done  = $this->property_broker_get_plugin_buttion($property_broker_plugin['slug'], $property_broker_plugin['name'], $property_broker_plugin['function']);
                    $property_broker_action['link']    = $property_broker_link_and_is_done['button'];
                    $property_broker_action['is_done'] = $property_broker_link_and_is_done['done'];
                    if (!$property_broker_action['is_done'] && (!isset($property_broker_actions_todo[$property_broker_action['id']]) || !$property_broker_actions_todo[$property_broker_action['id']])) {
                        $property_broker_act_count++;
                    }
                    $property_broker_recommended_actions[] = $property_broker_action;
                    $property_broker_actions_todo[]        = array('id' => $property_broker_action['id'], 'watch' => true);
                }
                return array('count' => $property_broker_act_count, 'actions' => $property_broker_recommended_actions);
            }

        }

        public function property_broker_get_recommended_plugins() {

            $property_broker_plugins = apply_filters('property_broker_recommended_plugins', array());
            return $property_broker_plugins;
        }

        public function property_broker_get_plugin_buttion($slug, $name, $function) {
                $property_broker_is_done      = false;
                $property_broker_button_html  = '';
                $property_broker_is_installed = $this->is_plugin_installed($slug);
                $property_broker_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $property_broker_is_activeted = (class_exists($function)) ? true : false;
                if (!$property_broker_is_installed) {
                    $property_broker_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $property_broker_plugin_install_url = wp_nonce_url($property_broker_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $property_broker_button_html        = sprintf('<a class="property-broker-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($property_broker_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'property-broker'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'property-broker')
                    );
                } elseif ($property_broker_is_installed && !$property_broker_is_activeted) {

                    $property_broker_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($property_broker_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $property_broker_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $property_broker_button_html = sprintf('<a class="property-broker-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($property_broker_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'property-broker'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'property-broker')
                    );
                } elseif ($property_broker_is_activeted) {
                    $property_broker_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'property-broker'));
                    $property_broker_is_done     = true;
                }

                return array('done' => $property_broker_is_done, 'button' => $property_broker_button_html);
            }
        public function is_plugin_installed($slug) {
            $property_broker_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $property_broker_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($property_broker_installed_plugins[$property_broker_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $property_broker_keys = array_keys($this->get_installed_plugins());
            foreach ($property_broker_keys as $property_broker_key) {
                if (preg_match('|^' . $slug . '/|', $property_broker_key)) {
                    return $property_broker_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Property_Broker_Plugin_Activation_WPElemento_Importer::get_instance();